using UnityEngine;
using System.Collections;

public class FPSEntity : MonoBehaviour {
	
	
	public bool isLocal = true;
	
	private CharacterController cc;
	
	
	public GameObject camHolder;
	private Vector3 camAngle;
	private bool crouched = false;
	
	public NetworkViewID viewID;
	
	public SophieNetworkScript theNetwork;
	
	public GameObject animObj;
	
	private Vector3 moveVec = Vector3.zero;
	
	
	public Color colA;
	public Color colB;
	public Color colC;
	
	public GameObject meshObj;
	
	private bool grounded;
	private float yMove = 0f;
	
	// Use this for initialization
	void Start () {
		
		
		Material[] mats = meshObj.renderer.materials;
		mats[0].color = colA;
		mats[1].color = colB;
		mats[2].color = colC;
		meshObj.renderer.materials = mats;
		
		
		if (isLocal){
			cc = GetComponent<CharacterController>();
			Camera.main.transform.parent = camHolder.transform;
			Camera.main.transform.localPosition = Vector3.zero;
			Camera.main.transform.localEulerAngles = Vector3.zero;
		}else{
			
		}
	}
	
	// Update is called once per frame
	void Update () {
		
		if (isLocal){
			camAngle.x -= Input.GetAxis("Mouse Y") * Time.deltaTime * 30f;
			camAngle.y += Input.GetAxis("Mouse X") * Time.deltaTime * 30f;
			if (camAngle.x>85f) camAngle.x = 85f;
			if (camAngle.x<-85f) camAngle.x = -85f;
			
			camHolder.transform.eulerAngles = camAngle;
			
			Vector3 inputVector = Vector3.zero;
			if (Input.GetKey("w")) inputVector += Camera.main.transform.forward;
			if (Input.GetKey("s")) inputVector -= Camera.main.transform.forward;
			if (Input.GetKey("d")) inputVector += Camera.main.transform.right;
			if (Input.GetKey("a")) inputVector -= Camera.main.transform.right;
			inputVector.y = 0f;
			inputVector.Normalize();
			
			if (!crouched){
				cc.Move(inputVector * Time.deltaTime * 10f);
			}else{
				cc.Move(inputVector * Time.deltaTime * 5f);
			}
			
			
			if (yMove<=0f){
				cc.Move(Vector3.up * -0.2f);
				grounded = cc.isGrounded;
				if (!grounded) cc.Move(Vector3.up * 0.2f);
			}else{
				grounded = false;
			}
			
			if (grounded){
				yMove = 0f;
				if (Input.GetKeyDown("space")){
					yMove = 4f;
				}
			}else{
				yMove -= Time.deltaTime * 10f;
			}
			cc.Move(Vector3.up * yMove * Time.deltaTime * 5f);
			
			crouched = false;
			if (Input.GetKey("left shift")) crouched = true;
			
			moveVec = inputVector;
			
			theNetwork.SendPlayer(viewID, transform.position, camAngle, crouched, moveVec);
		}
		
		if (!crouched){
			camHolder.transform.localPosition = Vector3.up * 0.7f;
		}else{
			camHolder.transform.localPosition = Vector3.zero;
		}
		
		
		
		//visible person model anims
		Vector3 lookDir = camHolder.transform.forward;
		lookDir.y = 0;
		lookDir.Normalize();
		animObj.transform.LookAt(animObj.transform.position + lookDir);
		
		if (yMove == 0f){
			if (moveVec.magnitude>0.1f){
				if (crouched){
					animObj.animation.Play("crouchrun");
				}else{
					animObj.animation.Play("run");
				}
				if (Vector3.Dot(moveVec, lookDir)<-0.5f){
					animObj.animation["crouchrun"].speed = -1;
					animObj.animation["run"].speed = -1;
				}else{
					animObj.animation["crouchrun"].speed = 1;
					animObj.animation["run"].speed = 1;
				}
			}else{
				if (crouched){
					animObj.animation.Play("crouch");
				}else{
					animObj.animation.Play("idle");
				}
			}
		}else{
			if (yMove>0f){
				animObj.animation.Play("rise");
			}else{
				animObj.animation.Play("fall");
			}
		}
		
	}
	
	public void UpdatePlayer(Vector3 pos, Vector3 ang, bool crouch, Vector3 move){
		transform.position = pos;
		camHolder.transform.eulerAngles = ang;
		crouched = crouch;
		moveVec = move;
	}
}
